<template>
  <div v-if="connected" class="wrapper">
    <div v-if="showMenu" class="menu-left">
      <div class="text-center">
          <strong class="text-white h2 logo">BWAI</strong>
      </div>
      <div class="justify-content-between">
        <div class="py-4">
          <span class="p-2 ">PROFILE</span>
        </div>
        <div v-if="isAdmin == true " :class="'links-container '+ (link == 0 ? 'active ' : ' c-pointer')" @click="next('/home')">
          <span class="menu-links" >
            <i class="fa fa-home mr-2"></i>
            Dashboard
          </span>
        </div>
        <div v-if="isAdmin == true " :class="'links-container '+ (link == 1 ? 'active ' : 'c-pointer ')" @click="next('/articles')">
          <span class="menu-links" > 
            <i class="fa fa-newspaper-o mr-2"></i>
            Articles
          </span>
        </div>
        <div v-if="isAdmin == true " :class="'links-container '+ (link == 2 ? 'active ' : 'c-pointer ')" @click="next('/reviews')">
          <span class="menu-links" > 
            <i class="fa fa-commenting mr-2"></i>
            <!-- fa-comments-o -->
            Reviews
          </span>
        </div>
        <div v-if="isAdmin == true " :class="'links-container '+ (link == 3 ? 'active ' : 'c-pointer ')" @click="next('/users')">
          <span class="menu-links" >
            <i class="fa fa-users mr-2"></i>
            Users
          </span>
        </div>

        <!-- Reviewers zone -->
        <div v-if="isAdmin == false " :class="'links-container '+ (link == 6 ? 'active ' : 'c-pointer ')" @click="next('/reviews-list')">
          <span class="menu-links" > 
            <i class="fa fa-newspaper-o mr-2"></i>
            Reviews
          </span>
        </div>

        <!-- <div :class="'links-container '+ (link == 2 ? 'active ' : 'c-pointer ')" @click="next('/avatars')">
          <span class="menu-links" >
            <i class="fa fa-user mr-2"></i>
            Avatars
          </span>
        </div> -->
      </div>
      <div>
        <div class="py-4">
          <span class="p-2 ">HELP</span>
        </div>
        <div class="links-container ">
          <span class="menu-links" > Contact</span>
        </div>
        <div class="links-container ">
          <span class="menu-links" > About</span>
        </div>
        <div class="links-container ">
          <span class="menu-links" > Report</span>
        </div>
      </div>
      
      <div class="mt-4 mb-5 footer">
        <div>
          <i class="fa fa-envelope mr-2"></i>
          <small class="text-center py-1">
            info@bwai.com
          </small>
        </div>
      </div>
    </div>
    <!-- fin menu left -->

    <div class="h-100 w-100 pb-1">
      <!-- header -->
      <div class="d-flex flex-row justify-content-between header-admin">
        <div class="fa-pull-left px-3">
          <i class="fa fa-bars text-primary2 mt-2 h4 c-pointer" 
            @click="showMenu=!showMenu" title="Cacher/Afficher le menu gauche">
          </i>
        </div>
        <div class="pull-right mr-5">
          <div class="row ">
            <div class="col-sm-2 mt-1 c-pointer">
              <div class="user-avatar">
                <span class="py-2 mx-auto"  @click="isDropSettingOpen=!isDropSettingOpen">
                  <img src="../assets/img/avatar_profile.png" class="img-fluid " />
                </span>
              </div>
            </div>
            <div class="col-sm mt-1 c-pointer">
              <div class="pt-2" @click="isDropSettingOpen=!isDropSettingOpen">
                <div class="userName">
                  <span class="text-capitalize mr-2">{{curUser.firstname ? curUser.firstname+' ' : ''}}</span>
                  <span class="text-uppercase">{{curUser.lastname ? curUser.lastname : ''}}</span>
                </div>
              </div>
            </div>
            <div class="my-2 col-sm-4 header-icons">
              <!-- <span class="text-gray px-2">|</span> -->
              <span class="c-pointer ">
                <i class="fa fa-bell"></i>
              </span>
              <span class="text-gray px-2">|</span>
              <span class="mr-2 c-pointer">
                <i class="fa fa-cog"></i>
              </span>
            </div>
            
            <span :class="'dropdown' + (isDropSettingOpen ? ' show' : '')">
              <div :class="'dropdown-menu dropdown-menu-right dropdown-menu-animated p-1' + (isDropSettingOpen ? ' show' : '')">
                
                <div class="my-2 c-pointer" @click="next('/users-profile')">
                  <span class="text-dark" >
                    <i class="fa fa-user " ></i>
                    Profile
                  </span>
                </div>
                <div class="dropdown-divider"></div>
                <div @click="logout" >
                  <span  class="text-dark c-pointer" >
                    <i @click="logout" class="fa fa-sign-out "></i>
                    Logout
                  </span>
                </div >
              </div>
            </span>
          </div>
        </div>
        
      </div>
      <!-- Fin header -->
      <div class="h-100 px-1 py-1 content">
        <slot></slot>
      </div>
    </div>

  </div>
</template>

<script>

export default {
  props: ['link',"title"],
  name: 'dashboard-layout',
  head() {
    return {
      title: "EJIMA - dashboard",
    };
  },
  data() {
    return {
      curUser: {},
      connected: false,
      showMenu: true,
      showDropDown: false,
      isDropSettingOpen: false,

      isAdmin: null,
    };
  },
  mounted() {
    this.init();
  },
  methods: {
    init(){
      if(localStorage.getItem('token') ){
        this.curUser = JSON.parse(localStorage.getItem('userInfos'));

        if(this.curUser.role == 'admin'){
          this.isAdmin = true;
        } else {
          if(this.curUser.role == 'reviewer'){
            this.isAdmin = false;
          } else {
            this.isAdmin = null;
          }
        }
        this.connected = true;
      } else{
        this.$alertify.warning("Vous n'êtes pas connecté. Veuillez-vous connecter !");
        this.$router.replace({ path: '/' });
        this.connected = false;
      }
    },
    next(address){
      this.$router.replace({ path: ''+address });
    },
    logout(){
      if(localStorage.getItem('token') ){
        localStorage.removeItem('userInfos');
        localStorage.removeItem('token');
        this.user = {}; 
        this.isConnected = false;
        this.$router.replace({ path: '/' });
      }
    }
  },
};
</script>

<style lang="scss" scoped>
  // avatars by Cécile L. Parker : https://dribbble.com/shots/5401553-User-avatars-Sketch-file

  $color1: #e7eff1;
  $color2: #fa8357;
  $color3: #b46f56;

  .logo{
    color: $color2;
  }

  .header-admin {
    border-bottom-color: black;
    border-bottom-width: 1px;
    background-color: #fff
  }

  .content {
    background-color: $color1;
    overflow: auto
  }

  .wrapper {
    background-color: $color1;
    height: 100%;
    display: flex;
    overflow: hidden;
  }

  .menu-links {
    font-size: 14px;
    padding: 10% 15%;
    color: #fff;
    text-align: left;
    // cursor: pointer;
  }

  .links-container {
    min-height: 44px;
    vertical-align: middle;
    background-color: transparent;
    padding-top: 10px;
    margin-left: 14px;
  }

  .active {
    background-color: $color2;
    border-top-right-radius: 20px;
    border-bottom-right-radius: 20px;
  }
  

  .links-container:hover {
    background-color: $color3;
    border-top-right-radius: 20px;
    border-bottom-right-radius: 20px;
  }

  .footer {
    padding: 2% 15%;
    font-size: 12px;
  }
  
</style>
